/* --------------------------------------------------------- */
/*	BASIC-E													 */
/*	Copyright(C)2006 t.hara									 */
/* ========================================================= */
/*	text editor												 */
/* --------------------------------------------------------- */

#ifndef __ZB_ERROR_H__
#define __ZB_ERROR_H__

class c_zb_error {
public:
	enum {
		NO_PROBLEM,
		FORCE_BREAK,
		ERROR_TOO_LONG_LINE,
		ERROR_ILLEGAL_LINE_NO,
		ERROR_SYNTAX,
		ERROR_DIVISION_BY_ZERO,
		ERROR_TYPE_MISMATCH,
		ERROR_NOT_FOUND_R_BLACKET,
		ERROR_OUT_OF_STRING_SPACE,
		ERROR_ILLEGAL_PARAMETER,
		ERROR_INVALID_LABEL,
		ERROR_DEVICE_IO_ERROR,
		ERROR_CANNOT_OPEN_FILE,
		ERROR_REDIMENSIONED_ARRAY,
		ERROR_SUBSCRIPT_OUT_OF_RANGE,
	};

	const char *get_error_message( int error_code ) {
		const char *p_message[] = {
			"No error",							/*	NO_PROBLEM */
			"Break",							/*	FORCE_BREAK */
			"Too long line",					/*	ERROR_TOO_LONG_LINE	*/
			"Illegal line number",				/*	ERROR_ILLEGAL_LINE_NO */
			"Syntax error",						/*	ERROR_SYNTAX */
			"Division by zero",					/*	ERROR_DIVISION_BY_ZERO */
			"Type mismatch",					/*	ERROR_TYPE_MISMATCH */
			"Not found right blacket ')'",		/*	ERROR_NOT_FOUND_R_BLACKET */
			"Out of string space",				/*	ERROR_OUT_OF_STRING_SPACE */
			"Illegal parameter",				/*	ERROR_ILLEGAL_PARAMETER */
			"Invalid label",					/*	ERROR_INVALID_LABEL */
			"Device I/O error",					/*	ERROR_DEVICE_IO_ERROR */
			"Cannot open file",					/*	ERROR_CANNOT_OPEN_FILE */
			"Redimensioned array",				/*	ERROR_REDIMENSIONED_ARRAY */
			"Subscript out of range",			/*	ERROR_SUBSCRIPT_OUT_OF_RANGE */
		};
		return p_message[ error_code ];
	}
};

#endif
